/*
 * Created on Fri Oct. 15, 2010
 * Copyright (c) 2010 by SAS Institute Inc., Cary, NC 27513
 */
package com.sas.solutions.brm.logging;

import java.util.Enumeration;
import java.util.Vector;

import org.apache.log4j.Appender;
import org.apache.log4j.Category;
import org.apache.log4j.Level;
import org.apache.log4j.Logger;
import org.apache.log4j.spi.HierarchyEventListener;
import org.apache.log4j.spi.LoggerFactory;
import org.apache.log4j.spi.LoggerRepository;
import org.apache.log4j.spi.LoggingEvent;

/**
 * Variant of LoggerRepository for which isDisabled() always returns false.
 * No other methods are implemented. For use in Logger objects that are not
 * part of the global hierarchy, such as MonitoredLogger.
 */
class BRMLoggerRepository implements LoggerRepository
{
  /**
     Add a {@link HierarchyEventListener} event to the repository.
  */
  public
  void addHierarchyEventListener(HierarchyEventListener listener)
  {
  }

  /**
     Returns whether this repository is disabled for a given
     level. The answer depends on the repository threshold and the
     <code>level</code> parameter. See also {@link #setThreshold}
     method.  */
  boolean isDisabled(int level)
  {
    return false;
  }

  /**
     Set the repository-wide threshold. All logging requests below the
     threshold are immediately dropped. By default, the threshold is
     set to <code>Level.ALL</code> which has the lowest possible rank.  */
  public
  void setThreshold(Level level)
  {
  }

  /**
      Another form of {@link #setThreshold(Level)} accepting a string
      parameter instead of a <code>Level</code>. */
  public
  void setThreshold(String val)
  {
  }

  public
  void emitNoAppenderWarning(Category cat)
  {
  }

  /**
     Get the repository-wide threshold. See {@link
     #setThreshold(Level)} for an explanation. */
  public
  Level getThreshold()
  {
    return Level.INFO;
  }

  public
  Logger getLogger(String name)
  {
    return null;
  }

  public
  Logger getLogger(String name, LoggerFactory factory)
  {
    return null;
  }

  public
  Logger getRootLogger()
  {
    return null;
  }

  public
  Logger exists(String name)
  {
    return null;
  }

  public
  void shutdown()
  {
  }

  public
  Enumeration getCurrentLoggers()
  {
    return (new Vector()).elements();
  }

  /**
     Deprecated. Please use {@link #getCurrentLoggers} instead.  */
  public
  Enumeration getCurrentCategories()
  {
    return (new Vector()).elements();
  }


  public
  void fireAddAppenderEvent(Category logger, Appender appender)
  {
  }

  public
  void resetConfiguration()
  {
  }

}

// end-of-file
