/*
 * Created on Feb 13, 2007
 * Copyright (c) 2007 by SAS Institute Inc., Cary, NC 27513
 */
package com.sas.solutions.brm.logging;

import org.apache.log4j.BasicConfigurator;
import org.apache.log4j.Logger;

/**
  * Configure log4j logging.
  *
  * See "The Complete Log4j Manual" by Ceki Glc, for log4j version 1.2.9,
  * December 2004 revision, p. 83.
  * 
  * See the on-line Log4j 1.2.x documentation:
  * http://logging.apache.org/log4j/1.2/index.html
  */
public class LogConfigurator
{
    private LogConfigurator()
    {
        // Un-callable constructor
    }

    /**
      * Configure log4j. If no log appenders have been set up, sets up log4j
      * via BasicConfigurator (which creates a basic console appender on the
      * root logger).
      * @see com.sas.solutions.brm.logging.LogUtil.getLog4jConfigURL()
      */
    public static void configure()
    {
        Logger root = Logger.getRootLogger();
        Enumeration appenders = root.getAllAppenders();
        if (!appenders.hasMoreElements())
        {
            System.out.println("BRM LogConfigurator: Using basic log4j configuration");
            BasicConfigurator.configure();
        }
    }
}
