/*
 * Created on Aug 06, 2010
 * Copyright (c) 2010 by SAS Institute Inc., Cary, NC 27513
 */
package com.sas.solutions.brm.webapp;

/**
 * Web application scripting utilities.
 */
public class WebappUtil
{
    def static getAdminHelper(props, logger)
    {
        def container = props.get("webappsrv.container.type");
        if (container == null)
        {
            logger.error("Missing config property: webappsrv.container.type");
            return null;
        }
        else if (container == "weblogic")
        {
            return new WLAdmin(props, logger);
        }
        else if (container == "websphere")
        {
            return new WSAdmin(props, logger);
        }
        else
        {
            logger.error(
                "Unsupported web application container: \"${container}\"");
            return null;
        }
    }
}
