package com.sas.solutions.brm.webservice;

class JomaWrapperInternal {
    def log = null;
    def host = "";
    def port = "";
    def user = "";
    def password = "";
    def reposFQID = null;
    def reposId = null;
    def objStore = null;
    
    def mdFactory = null;
    def mdOMIUtil = null;

    public JomaWrapperInternal(log)
    {
        this.log = log;
    }

    void connect(host, port, user, password) {
        this.host = host;
        this.port = port;
        this.user = user;
        this.password = password;

        log.debug("Connecting to metadata server:");
        log.debug("    Host: " + host);
        log.debug("    Port: " + port);
        log.debug("    User: " + user);

        mdFactory = new com.sas.metadata.remote.MdFactoryImpl(false);

        // Connect to the metadata server
        com.sas.metadata.remote.MdOMRConnection connection = mdFactory.getConnection();
        connection.makeOMRConnection(host, port, user, password);
        
        // Create the joma object store
        objStore = mdFactory.createObjectStore();

        log.debug("Connected to metadata server");
        
        mdOMIUtil = mdFactory.getOMIUtil();

        // Get the repository information
        reposFQID = mdOMIUtil.getFoundationReposID();
       	reposId = reposFQID.substring(9);
        
    }

    void disconnect() {
        // Disconnect from the metadata server
        objStore.dispose();
        mdFactory.closeOMRConnection();
    }

    def getMetadataObjects(type, search) {
        def xmlSelect = "<XMLSelect search=\"" + type + "[" + search + "]\" />";

        log.debug("Searching for metadata");
        log.debug("    Type: " + type);
        log.debug("    Search: " + xmlSelect);

        def objects = mdOMIUtil.getMetadataObjectsSubset(objStore, 
                                                            reposFQID,
                                                            type,
                                                            com.sas.metadata.remote.MdOMIUtil.OMI_XMLSELECT |
                                                            com.sas.metadata.remote.MdOMIUtil.OMI_ALL_SIMPLE |
                                                            com.sas.metadata.remote.MdOMIUtil.OMI_TEMPLATE |
                                                            com.sas.metadata.remote.MdOMIUtil.OMI_GET_METADATA,
                                                            xmlSelect);

        log.debug("Found metadata count: " + objects.size());
        for (def it = objects.iterator(); it.hasNext(); ) {
            def obj = it.next();
            log.debug("    Name: " + obj.getName());
        }

        return objects;
    }

    def getMetadataObject(type, searchStr) {
        def retval = null;
    
        def objects = getMetadataObjects(type, searchStr);
        if (objects != null && objects.size() > 0) {
            retval = objects.get(0);
        }
    
        return retval;
    }
}

// end-of-file
