package com.sas.solutions.brm.webservice;

/**
 * PWCBHandler sets the password for a given user when invoked by apache's
 * Rampart. This handler class sets the password on the apache Callback when
 * it's invoked and simply sets that value to whatever password was given to
 * construct the PWCBHandler assuming the usernames match.
 * 
 * @author zamars
*/
class PWCBHandler
		implements javax.security.auth.callback.CallbackHandler {
	
	private String	_username, _password;
	public PWCBHandler(String username, String password) {
		_username = username;
		_password = password;
	}
	/**
	 * Set the credentials on the Callback.
	 */
	public void handle(javax.security.auth.callback.Callback[] callbacks) throws IOException, javax.security.auth.callback.UnsupportedCallbackException {
		for (int i = 0; i < callbacks.length; i++) {
			org.apache.ws.security.WSPasswordCallback pwcb = (org.apache.ws.security.WSPasswordCallback)callbacks[i];
			if (pwcb.getIdentifer().equals(_username)) {
				pwcb.setPassword(_password);
				break;
			}
		}
	}
}

// end-of-file
